﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=7.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim isOpen As Boolean
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.

	Private IPBOOT As CheckBox
	Private AUTOBRI As CheckBox

	Dim AppList As ListView
	Dim p As Panel
	Private ScrollView1 As ScrollView
	Private BIGTIME As CheckBox
	Private WEEKDAY As CheckBox
	Private RAINBOW As CheckBox
	Private ALEXA As CheckBox
	Private SOUND As CheckBox
	Private UPDATE As CheckBox
	Private WEATHER As CheckBox
	Private TWITTER As CheckBox
	Private GOL As CheckBox
	Private FACEBOOK As CheckBox
	Private DHT As CheckBox
	Private PET As CheckBox
	Private FIRE As CheckBox
	Private YOUTUBE As CheckBox
End Sub

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	isOpen=True
	Main.requestSettings=False

	Activity.LoadLayout("settings")
	ScrollView1.Panel.LoadLayout("scrollLayout")
	getSettings
	AppList.Initialize("applist")

	AppList.TwoLinesAndBitmap.label.TextColor=Colors.Black

	p.Initialize("applist")
	p.Visible=False
	p.AddView(AppList,0,0,100%x,100%y)
	p.Color=Colors.White
	Activity.AddView(p,0,0,100%x,100%y)

	IPBOOT.Initialize("")
End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)
	If UserClosed Then
		StartActivity(Main)
	End If
	isOpen=False
End Sub

Sub getSettings
	If Starter.jsonmsg=Null Then 
		Return
	End If
	Dim JSON As JSONParser
	Dim Map1 As Map
	JSON.Initialize(Starter.jsonmsg)
	Map1 = JSON.NextObject

	WEATHER.Checked =bin2Bool(Map1.Get("WEATHER_ACTIVE"))
	TWITTER.Checked =bin2Bool(Map1.Get("TWITTER_ACTIVE"))
	GOL.Checked =bin2Bool(Map1.Get("GOL_ACTIVE"))
	YOUTUBE.Checked =bin2Bool(Map1.Get("YT_ACTIVE"))
	PET.Checked =bin2Bool(Map1.Get("PET_ACTIVE"))
	DHT.Checked =bin2Bool(Map1.Get("DHT_ACTIVE"))
	FACEBOOK.Checked =bin2Bool(Map1.Get("FB_ACTIVE"))
	FIRE.Checked =bin2Bool(Map1.Get("FIRE_ACTIVE"))

	IPBOOT.Checked = bin2Bool(Map1.Get("SHOW_IP_ON_BOOT"))
	AUTOBRI.Checked = bin2Bool(Map1.Get("AUTO_BRIGHTNESS"))
	BIGTIME.Checked =bin2Bool(Map1.Get("BIG_TIME"))
	WEEKDAY.Checked =bin2Bool(Map1.Get("SHOW_WEEKDAY"))
	RAINBOW.Checked =bin2Bool(Map1.Get("RAINBOW"))
	ALEXA.Checked =bin2Bool(Map1.Get("ALEXA_ACTIVE"))
	SOUND.Checked =bin2Bool(Map1.Get("SOUND"))
	UPDATE.Checked =bin2Bool(Map1.Get("AUTO_UPDATE"))
	

End Sub

Sub bin2Bool(bin As String) As Boolean
	If bin="1" Then
			 Return True
		Else 
			Return False
	End If
End Sub

Sub Button5_Click
	Dim JSONList As List
	JSONList.Initialize
	Dim Set As Map
	Set.Initialize
	
	Set.put("WEATHER_ACTIVE", WEATHER.Checked)
	Set.put("TWITTER_ACTIVE", TWITTER.Checked)
	Set.put("GOL_ACTIVE", GOL.Checked)
	Set.put("YT_ACTIVE", YOUTUBE.Checked)
	Set.put("PET_ACTIVE", PET.Checked)
	Set.put("DHT_ACTIVE", DHT.Checked)
	Set.put("FB_ACTIVE", FACEBOOK.Checked)
	Set.put("FIRE_ACTIVE", FIRE.Checked)
	
	Set.put("SHOW_IP_ON_BOOT", IPBOOT.Checked)
	Set.put("AUTO_BRIGHTNESS", AUTOBRI.Checked)
	Set.put("BIG_TIME", BIGTIME.Checked)
	Set.put("SHOW_WEEKDAY", WEEKDAY.Checked)
	Set.put("RAINBOW", RAINBOW.Checked)
	Set.put("ALEXA_ACTIVE", ALEXA.Checked)
	Set.put("SOUND", SOUND.Checked)
	Set.put("AUTO_UPDATE", UPDATE.Checked)
	JSONList.add(Set)
    Dim JSONGenerator As JSONGenerator
	JSONGenerator.Initialize2(JSONList)
	Dim JSONstring As String
	JSONstring = JSONGenerator.ToString.Replace("[","").Replace("]","").Replace(" ","")
	CallSub2(Starter,"sendCommand","settings%"&JSONstring)
	isOpen=False
	StartActivity(Main)
End Sub

Sub Button1_Click
	Activity.AddMenuItem("Speichern","save")
	p.Visible=True
	ProgressDialogShow2("Loading Apps",False)
	AppList.Clear
	Dim args(1) As Object
	Dim Obj1, Obj2, Obj3, Obj4 As Reflector
	Dim size, i, flags, count As Int
	Dim Types(1), msg, name, packagename As String
	Obj1.Target = Obj1.GetContext
	Obj1.Target = Obj1.RunMethod("getPackageManager") ' PackageManager
	Obj2.Target = Obj1.RunMethod2("getInstalledPackages", 0, "java.lang.int") ' List<PackageInfo>
	size = Obj2.RunMethod("size")
	For i = 0 To size -1
		Obj3.Target = Obj2.RunMethod2("get", i, "java.lang.int") ' PackageInfo
		packagename = Obj3.GetField("packageName")
		Obj3.Target = Obj3.GetField("applicationInfo") ' ApplicationInfo
		flags = Obj3.GetField("flags")
		Dim icon As BitmapDrawable '  *** NEW LINE  ***
		If Bit.And(flags, 1)  = 0 Then
		'app is not in the system image
      args(0) = Obj3.Target
			Types(0) = "android.content.pm.ApplicationInfo"
			name = Obj1.RunMethod4("getApplicationLabel", args, Types)
			icon = Obj1.RunMethod4("getApplicationIcon", args, Types)  '  *** NEW LINE  ***
			AppList.AddTwoLinesAndBitmap2(name,packagename,icon.Bitmap,packagename)
			Sleep(10)
   End If      
		Next
		ProgressDialogHide

	Return
	
	
End Sub

Sub applist_ItemClick (Position As Int, Value As Object)
	Log(AppList.GetItem(Position))
	Private jo = AppList As JavaObject
	Private cdw As ColorDrawable
	cdw.Initialize(Colors.Cyan, 0)
	jo.RunMethod("setSelector", Array(cdw))
End Sub

Sub NOTIFICATION_CheckedChange(Checked As Boolean)
If Checked=True Then
	Dim ph As Phone
	Dim nstr, pstr As String
	Dim r As Reflector
	pstr = r.GetStaticField("anywheresoftware.b4a.BA", "packageName")
	nstr = ph.GetSettings("enabled_notification_listeners")
	If  Not (nstr.Contains(pstr)) Then
		Dim In As Intent
		In.Initialize("android.settings.ACTION_NOTIFICATION_LISTENER_SETTINGS", "")
		StartActivity(In)
		Else
		NotificationService.notifyActive=True
	End If
	Else 
		NotificationService.notifyActive=False
	End If
End Sub

Sub nextApp_Click
	CallSub2(Starter,"sendCommand","next%0")
End Sub