﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim UDPSocket1 As UDPSocket
	Dim data() As Byte
	Dim jsonmsg As String
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.                             
	UDPSocket1.Initialize("UDP", 52830, 8000)
End Sub

Sub Service_Start (StartingIntent As Intent)
	

End Sub



Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub sendCommand(msg As String)
	data = msg.GetBytes("UTF8")
	For i = 1 To 3
		Dim Packet As UDPPacket
		Packet.Initialize(data,GetBroadcastAddress,52829)
		UDPSocket1.Send(Packet)
		Wait For (CheckResponse(2000)) Complete (Success As Boolean)
		If Success Then Exit
	Next
	If i = 4 Then
		Log("Failed to send...")
	End If
End Sub



Sub CheckResponse (Timeout As Int) As ResumableSub
	Dim result(1) As Object
	Dim rs As ResumableSub = WaitForMessageHelper(result)
	Do While Timeout > 0 And rs.Completed = False
		Sleep(100)
		Timeout = Timeout - 100
	Loop
	If rs.Completed Then
		Dim packet As UDPSocket = result(0)
		'check the response
		Return True
	Else
		Return False
	End If
End Sub

Sub WaitForMessageHelper (Result() As Object) As ResumableSub
	Wait For UDP_PacketArrived (Packet As UDPPacket)
	Result(0) = Packet
	Return Null
End Sub


Sub UDP_PacketArrived (Packet As UDPPacket)
	Dim s As String


	s = BytesToString(Packet.Data, Packet.Offset, Packet.Length, "UTF8")
	If s.Contains("SHOW_IP_ON_BOOT") Then
		jsonmsg=s
		ProgressDialogHide
		CallSub(Main,"getSettings")
	End If
		

End Sub
	
Sub GetBroadcastAddress As String
	Dim niIterator As JavaObject
	niIterator = niIterator.InitializeStatic("java.net.NetworkInterface").RunMethod("getNetworkInterfaces", Null)
	Do While niIterator.RunMethod("hasMoreElements", Null)
		Dim ni As JavaObject = niIterator.RunMethod("nextElement", Null)
		If ni.RunMethod("isLoopback", Null) = False Then
			Dim addresses As List = ni.RunMethod("getInterfaceAddresses", Null)
			For Each ia As JavaObject In addresses
				Dim broadcast As Object = ia.RunMethod("getBroadcast", Null)
				If broadcast <> Null Then
					Dim b As String = broadcast
					Return b.SubString(1)
				End If
			Next
		End If
	Loop
	Return ""
End Sub


